package shapecalculus;

import repast.simphony.random.RandomHelper;
import repast.simphony.space.grid.Grid;
import repast.simphony.space.grid.GridAdder;
import repast.simphony.space.grid.GridDimensions;
import repast.simphony.space.grid.GridPoint;

public class CustomRandomGridAdder<T> implements GridAdder<T> {

	@Override
	public void add(Grid<T> space, T obj) {
		GridDimensions dims = space.getDimensions();
		int[] location = new int[dims.size()];
		findLocation(location, dims);
		while (!space.moveTo(obj, location)) {
			findLocation(location, dims);
		}
		if (obj instanceof Shape) {
			((Shape) obj).setDiscretePosition(new GridPoint(location[0],
					location[1], location[2]));
		}

	}

	private void findLocation(int[] location, GridDimensions dims) {
		int[] origin = dims.originToIntArray(null);
		for (int i = 0; i < location.length; i++) {
			location[i] = RandomHelper.getUniform().nextIntFromTo(0,
					dims.getDimension(i) - origin[i] - 1);
		}
	}

}
