package shapecalculus.behaviour;

import java.util.Iterator;

import shapecalculus.BasicShape;

public class Delay extends AtomicBehaviour {

	private double delay;
	private double decrement;
	private BasicShape shape;

	public Delay(double delay, BasicShape shape) {
		this.delay = delay;
		this.decrement = 1;
		this.shape = shape;
	}

	public Delay(double delay, double decrement, BasicShape shape) {
		this.delay = delay;
		this.decrement = decrement;
		this.shape = shape;
	}

	@Override
	public int perform(Iterator<Integer> path) {
		int ret = 0;
		if (delay > 0) {
			delay = delay - this.decrement;
			ret = 1;
		}
		return ret;
	}

	public double getDelay() {
		return delay;
	}

	public double getDecrement() {
		return decrement;
	}

	@Override
	public boolean canPerform() {
		return delay >= 0;
	}

	public String toString() {
		return ("e(" + delay + ")");
	}

	public Object clone() {
		Delay d = new Delay(this.delay, this.decrement, this.shape);
		d.initPath(this.path);
		return d;
	}

	@Override
	public BasicShape getShape() {
		return this.shape;
	}

}
