package shapecalculus.behaviour;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import repast.simphony.random.RandomHelper;

public class DistanceActionDistribution {

	private List<DistanceSensible> actions;
	private List<Double> values;
	private Double[] sorted;
	private int currentIndex;

	public DistanceActionDistribution() {
		actions = new ArrayList<DistanceSensible>();
		values = new ArrayList<Double>();
		currentIndex = -1;
	}

	public void add(DistanceSensible action, double distance) {
		double probability = (action.getChannel().getPriority() + RandomHelper.getUniform().nextDoubleFromTo(- 0.05, 0.05))
				/ (distance+1);
//		if(action.getShape() instanceof MatureOsteoblast)
//			System.out.println(probability);
		actions.add(action);
		values.add(probability);
	}

	public DistanceSensible getNext() {
		DistanceSensible ret = null;
		if (currentIndex == -1) {
			sorted = values.toArray(new Double[0]);
			Arrays.sort(sorted);
			currentIndex = 0;
		}
		if (currentIndex < sorted.length) {
			ret = actions.get(values.indexOf(sorted[currentIndex]));
			currentIndex++;
		}
		return ret;
	}
}
