package shapecalculus.behaviour;

import repast.simphony.space.grid.GridPoint;
import shapecalculus.BasicShape;
import shapecalculus.Surface;
import shapecalculus.behaviour.channel.Channel;

public abstract class DistanceSensible extends AtomicBehaviour {

	protected Channel channel;
	protected DistanceSensible synchronizingAction;

	public Channel getChannel() {
		return this.channel;
	}
	
	public Surface getSurface(){
		return this.channel.getSurface();
	}

	public BasicShape getShape() {
		return this.channel.getShape();
	}

	public boolean isOutput() {
		return this.channel.isOutput();
	}

	public void setSynchronizingAction(DistanceSensible otherAction) {
			this.synchronizingAction = otherAction;
	}

	public abstract GridPoint getExtent();

	public abstract boolean isCompatibleWith(DistanceSensible action);
	
	public abstract Behaviour returnDistanceSensibleEquivalent(int[] directions);
}
