package shapecalculus.behaviour;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

public abstract class NonAtomicBehaviour implements Behaviour {

	protected List<Integer> path;
	protected List<Behaviour> operands;
	protected int currentIndex;
	protected boolean isPathInitialized;

	public List<Integer> getPath() {
		return this.path;
	}

	public void initPath(List<Integer> parentPath) {
		if (parentPath != null) {
			this.isPathInitialized = true;
			this.path = new ArrayList<Integer>();
			this.path.addAll(parentPath);
			List<Integer> l;
			for (int i = 0; i < this.operands.size(); i++) {
				Behaviour b = this.operands.get(i);
				l = new ArrayList<Integer>();
				l.addAll(parentPath);
				l.add(i);
				b.initPath(l);
			}
		}
	}

	public abstract Set<AtomicBehaviour> getEnabledActions();

	public abstract Object clone();

	public abstract int perform(Iterator<Integer> path);

}
