package shapecalculus.boneremodelling;

import repast.simphony.space.continuous.NdPoint;
import shapecalculus.ActionsContext;
import shapecalculus.behaviour.ActionDispatcher;
import shapecalculus.behaviour.AtomicBehaviour;
import shapecalculus.behaviour.Bind;
import shapecalculus.behaviour.DistanceSensible;
import shapecalculus.behaviour.channel.OutChannel;

public class BRActionDispatcher extends ActionDispatcher {

	public BRActionDispatcher(ActionsContext actContext) {
		super(actContext);
	}

	@Override
	public void dispatchAction(AtomicBehaviour action) {
		super.dispatchAction(action);
		if (action instanceof Bind) {
			DistanceSensible b = (DistanceSensible) action;
			NdPoint currPos = b.getShape().getPosition();
			double x = currPos.getX();
			double y = currPos.getY();
			if (b.isOutput()) {
				OutChannel chan = (OutChannel) b.getChannel();
				if (chan.getChannelName().equals("rank"))
					BRContext.ranklField.add(b.getShape()
							.getDiscretePosition(), ParametersManager
							.getObAttractionFactor());
				else if (chan.getChannelName().equals("rank'")) {
					double factor = BRContext.currentOyNum > 0 ? BRContext.initialOyNum
							/ BRContext.currentOyNum
							: 1;
					BRContext.ranklField
							.add(b.getShape().getDiscretePosition(),
									ParametersManager
											.getFractureAttractionFactor()* factor);
				} else if (chan.getChannelName().equals("ob"))
					BRContext.obAttraction.insertPoint(x, y, 0);
			}
		}
	}
}
