package shapecalculus.boneremodelling;

import java.util.ArrayList;
import java.util.List;

import repast.simphony.random.RandomHelper;
import repast.simphony.util.SimUtilities;
import shapecalculus.behaviour.DistanceSensible;

public class BestDistanceAction {

	private double bestScore;
	private List<DistanceSensible> actions;

	public BestDistanceAction() {
		bestScore = Double.MIN_VALUE;
		actions = new ArrayList<DistanceSensible>();
	}

	public void add(DistanceSensible action, double distance) {
		// double score = (action.getChannel().getPriority() +
		// RandomHelper.getUniform().nextDoubleFromTo(-0.1, 0.1))
		// / (distance + 1);
		double score = BRContext.reg.getExponential().nextDouble(
				(distance + 0.1) / action.getChannel().getPriority());
		if (score == bestScore)
			actions.add(action);
		else if (score > bestScore) {
			bestScore = score;
			actions.clear();
			actions.add(action);
		}
		// if(action.getShape() instanceof MatureOsteoblast)
		// System.out.println(probability);
	}

	public DistanceSensible getBest() {
		if (this.actions.size() > 0) {
			SimUtilities.shuffle(this.actions, RandomHelper.getUniform());
			return this.actions.get(0);
		}
		return null;
	}
}
