package shapecalculus.boneremodelling;

import repast.simphony.context.Context;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.valueLayer.GridValueLayer;

public class BoneNode {

	private int[] coords;
	private double value;
	private Context context;

	public BoneNode(Context context, int... coords) {
		this.coords = coords;
		this.value = 0;
		this.context = context;
	}

	public int[] getCoords() {
		return coords;
	}
	
	public int getX(){
		return this.coords[0];
	}
	
	public int getY(){
		return this.coords[1];
	}

	public double getValue() {
		return value;
	}

	@ScheduledMethod(start = 1, interval = 1)
	public void updateValue() {
		GridValueLayer vl = (GridValueLayer) context.getValueLayer("BoneMass");
		this.value = vl.get(coords[0], coords[1]);
	}

}
