package shapecalculus.boneremodelling;

import java.util.Iterator;

import repast.simphony.random.RandomHelper;
import repast.simphony.space.SpatialException;
import repast.simphony.valueLayer.GridValueLayer;
import shapecalculus.BasicShape;
import shapecalculus.Utils;
import shapecalculus.behaviour.AtomicBehaviour;

public class Formation extends AtomicBehaviour {

	private BasicShape ob;
	private int radius;

	public Formation(BasicShape ob) {
		this.ob = ob;
		// this.radius = 2;
		this.radius = 2;
	}

	@Override
	public int perform(Iterator<Integer> path) {
		GridValueLayer vl = (GridValueLayer) ob.getContext().getValueLayer(
				"BoneMass");
		double[] coords = Utils.continuize(ob.getDiscretePosition())
				.toDoubleArray(null);
		double aging=ParametersManager.getAgingFactor();
		double increment = ParametersManager.getBoneFormation()/(RandomHelper.getUniform().nextDoubleFromTo(1, aging));
		int[] pos = ob.getDiscretePosition().toIntArray(null);
		for (int i = -radius; i <= radius; i++)
			for (int j = -radius; j <= radius; j++) {
				try {
					double value = vl.get(coords[0] + i, coords[1] + j);
					double newvalue = Math.min(100, value + increment);
					BRContext.boneFormed+=(newvalue-value);
					vl.set(newvalue, pos[0] + i, pos[1] + j);
//					increment = increment - newvalue + value;
				} catch (SpatialException e) {

				}
			}

		return 1;
	}

	@Override
	public boolean canPerform() {
		return true;
	}

	@Override
	public BasicShape getShape() {
		return ob;
	}

	@Override
	public Object clone() {
		return new Formation(ob);
	}

}
