package shapecalculus.boneremodelling;

import repast.simphony.context.Context;
import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.grid.Grid;
import shapecalculus.ShapeException;
import shapecalculus.Surface;
import shapecalculus.behaviour.Behaviour;
import shapecalculus.behaviour.BehaviourException;
import shapecalculus.behaviour.Bind;
import shapecalculus.behaviour.Choice;
import shapecalculus.behaviour.Delay;
import shapecalculus.behaviour.Recursion;
import shapecalculus.behaviour.Sequence;
import shapecalculus.behaviour.channel.InChannel;

public class MatureOsteoblast extends ShapeKiller {

	public MatureOsteoblast(double mass, Context context, Grid<Object> grid,ContinuousSpace<Object> space,
			Behaviour behaviour) {
		super(mass, context, grid, space, behaviour);
		
	}
	@Override
	public void activateKiller() {
		try {
			Behaviour[] bs = new Bind[4];
			for (int i = 0; i < 4; i++)
				bs[i] = new Bind(new InChannel("rank", this, new Surface(i), 1));
			int to = ParametersManager.getObOPGTime();
			int ao = ParametersManager.getOPGProductionRate();
			this.setBehaviour(new Sequence(new Delay(to*10, this),
					new Recursion(new Choice(bs), ao)/*, new Recursion(
							new Formation(this))*/));
		} catch (ShapeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (BehaviourException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
	}

}
