package shapecalculus.boneremodelling;

import repast.simphony.context.Context;
import repast.simphony.space.continuous.ContinuousSpace;
import repast.simphony.space.grid.Grid;
import shapecalculus.behaviour.Behaviour;
import shapecalculus.behaviour.BehaviourException;
import shapecalculus.behaviour.Delay;
import shapecalculus.behaviour.Recursion;
import shapecalculus.behaviour.Sequence;

public class OsteoblastProducer extends ShapeKiller {

	public OsteoblastProducer(double mass, Context context, Grid<Object> grid,
			ContinuousSpace<Object> space, Behaviour behaviour) {
		super(mass, context, grid, space, behaviour);
	}

	@Override
	public void activateKiller() {
		int to = ParametersManager.getObOPGTime();
		try {
			this.setBehaviour(new Sequence(new Delay(to/** 10 */
			, this), new Recursion(new Formation(this))));
		} catch (BehaviourException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
