package shapecalculus.boneremodelling;

import java.util.Iterator;

import repast.simphony.space.SpatialException;
import repast.simphony.valueLayer.GridValueLayer;
import shapecalculus.BasicShape;
import shapecalculus.Utils;
import shapecalculus.behaviour.AtomicBehaviour;

public class Resorption extends AtomicBehaviour {

	private Osteoclast oc;
	private int radius;

	public Resorption(Osteoclast oc) {
		this.oc = oc;
		this.radius = 2;
	}

	@Override
	public int perform(Iterator<Integer> path) {
		GridValueLayer vl = (GridValueLayer) oc.getContext().getValueLayer(
				"BoneMass");
		double[] coords = Utils.continuize(oc.getDiscretePosition())
				.toDoubleArray(null);
		double decrement = ParametersManager.getBoneResorption();
		int[] pos = oc.getDiscretePosition().toIntArray(null);
		for (int i = -radius; i <= radius; i++)
			for (int j = -radius; j <= radius; j++) {
				try {
					double value = vl.get(coords[0] + i, coords[1] + j);
					double newvalue = Math.max(0, value - decrement);
					BRContext.boneAbsorbed+=(value-newvalue);
					vl.set(newvalue, pos[0] + i, pos[1] + j);
//					decrement = decrement + newvalue - value;
				} catch (SpatialException e) {

				}
			}
		this.oc.setActive(true);
		return 1;
	}

	@Override
	public boolean canPerform() {
		return true;
	}

	@Override
	public BasicShape getShape() {
		return oc;
	}

	@Override
	public Object clone() {
		return new Resorption(oc);
	}

}
