package shapecalculus.physics;

import repast.simphony.context.ContextEvent;
import repast.simphony.context.ContextListener;
import repast.simphony.space.continuous.NdPoint;
import shapecalculus.Shape;
import shapecalculus.Utils;

public abstract class ContextForceField<T> implements ContextListener<T> {

	protected NdPoint applicationPoint;

	public ContextForceField(NdPoint applicationPoint) {
		this.applicationPoint = applicationPoint;
	}

	@Override
	public void eventOccured(ContextEvent<T> evt) {
		T s = evt.getTarget();
		ContextEvent.EventType type = evt.getType();
		if (type == ContextEvent.ADDED && s instanceof Shape) {
			applyTo((Shape) s);
		}
	}

	public NdPoint getDistance(Shape s){
		return Utils.sumPoints(s.getPosition(),Utils.negPoint(this.applicationPoint));
	}
	public abstract void applyTo(Shape s);
}
