package shapecalculus.physics;

import repast.simphony.space.continuous.NdPoint;
import shapecalculus.Shape;
import shapecalculus.Utils;

public class ElectricField extends ContextForceField {

	public static final double epsilon_0 = 8.8541878176E-12;
	private double intensity;

	public ElectricField(NdPoint applicationPoint, double intensity) {
		super(applicationPoint);
		this.intensity = intensity;
	}

	@Override
	public void applyTo(Shape s) {
		s.addMotion(new Motion() {
			@Override
			public NdPoint calculateVelocity(Shape s) {
				NdPoint distance = getDistance(s);
				double distanceScalar = Utils.vectorIntensity(distance);
				double k = intensity
						/ (s.getMass()*4 * Math.PI * epsilon_0 * (Math.pow(distanceScalar,
								3)));
				return new NdPoint(distance.getX() * k, distance.getY() * k,
						distance.getZ() * k);
			}

		});

	}

}
